SWAPON(8)

NAZWA
swapon, swapoff - włącza/wyłącza urządzenia oraz pliki stronicowania i wymiany

SKŁADNIA

swapon [opcje] [plik-specjalny...]

swapoff [-va] [plik-specjalny...]

OPIS

Polecenie swapon jest używane do określania urządzeń do stronicowania i wymiany.

Urządzenie lub plik może być podany za pomocą parametru plik-specjalny. Może mieć on postać -L etykieta lub -U uuid, aby określić urządzenie za pomocą etykiety lub uuid (unikatowego identyfikatora).

Odwołanie do swapon normalnie powinno się pojawiać w systemowych skryptach uruchomieniowych, udostępniając wszystkie urządzenia wymiany, dzięki czemu stronicowanie i wymiana jest rozłożone między wiele urządzeń i plików.

Polecenie swapoff wyłącza wymianę na podanych urządzeniach i plikach. Jeśli użyto opcji -a, to swap jest wyłączany na wszystkich znanych urządzeniach i plikach wymiany (zgodnie z plikiem /proc/swaps lub /etc/fstab).

OPCJE

-a, --all
    Udostępnia wszystkie urządzenia oznaczone jako "swap" w pliku /etc/fstab, z wyjątkiem plików z opcją "noauto". Urządzenia, które są już używane jako swap, są po cichu pomijane.

-d, --discard [=tryb]
    Enable swap discards, if the swap backing device supports the discard or trim operation. This may improve performance on some Solid State Devices, but often it does not. The option allows one to select between two available swap discard policies:

    --discard=once
        to perform a single-time discard operation for the whole swap area at swapon; or

    --discard=pages
        to asynchronously discard freed swap pages before they are available for reuse.

    If no policy is selected, the default behavior is to enable both discard types. The /etc/fstab mount options discard, discard=once, or discard=pages may also be used to enable discard flags.

-e, --ifexists
    Pomija po cichu nieistniejące urządzenia. Opcja montowania nofail w /etc/fstab może być również użyta do pomijania nieistniejących urządzeń.

-f, --fixpgsz
    Ponownie inicjuje przestrzeń swap (exec mkswap), jeśli rozmiar strony nie pasuje do rozmiaru podawanego przez obecnie uruchomione jądro. Polecenie mkswap(8) inicjuje całe urządzenie i nie sprawdza go pod kątem błędnych bloków.

-h, --help
    Wyświetla ten tekst i kończy pracę.

-L etykieta
    Używa partycji z określoną etykietą (potrzebny jest w tym celu dostęp do /proc/partitions).

-o, --options opcje
    Podaje opcje swap jako rozdzielona przecinkami lista zgodna z formatem fstab. Na przykład:

    swapon -o pri=1,discard=pages,nofail /dev/sda2

    Łańcuch opts jest przetwarzany ostatni i nadpisuje wszystkie inne opcje linii poleceń.

-p, --priority priorytet
    Określa priorytet urządzenia wymiany. Priorytet jest wartością z przedziału pomiędzy -1 a 32767. Wyższa liczba oznacza wyższy priorytet. Podręcznik polecenia swapon(2) zawiera pełny opis priorytetów swap. Do pliku /etc/fstab można dodać opcję pri=wartość, która będzie używana ze swapon -a. Jeśli nie zdefiniowano priorytetu,to wartością domyślną jest -1.

-s, --summary
    Wyświetla podsumowanie użycia swapu wg urządzenia. Jest to odpowiednik cat /proc/swaps. Ten format wyjścia jest PRZESTARZAŁY. Zalecany format --show dostarcza większej kontroli nad danymi wyjściowymi.

--show[=kolumna...]
    Wyświetla możliwą do zdefiniowania tabelę obszarów swap. Lista dostępnych kolumn można znaleźć w wyjściu opcji --help.

--output-all
    Wypisuje wszystkie dostępne kolumny.

--noheadings
    Nie wyświetla nagłówków w wyjściu opcji --show.

--raw
    Nie wyrównuje kolumn tabeli wyświetlanej przez --show.

--bytes
    Opcja --show wyświetla rozmiar przestrzeni wymiany w bajtach, a nie w jednostkach czytelnych dla użytkownika.

-U uuid
    Używa partycji o określonym uuid (unikalnym identyfikatorze).

-v, --verbose
    Więcej szczegółów.

-V, --version
    Wyświetla informacje o wersji i kończy działanie.

KOD ZAKOŃCZENIA

swapoff ma następujące wartości kodów zakończenia od wersji v2.36:

0
    sukces

2
    system ma zbyt mało pamięci aby zaprzestać używania przestrzeni wymiany (OOM)

4
    wywołanie systemowe swapoff nie powiodło się z innych przyczyn

8
    błąd wywołania systemowego niezwiązany z swapoff (za mało pamięci itp.)

16
    błąd użycia lub składni

32
    wszystkie wywołania swapoff nie powiodły się (przy użyciu opcji --all)

64
    część wywołań swapoff powiodła się (przy użyciu opcji --all)

Polecenie swapoff --all zwraca 0 (wszystkie się powiodły), 32 (wszystkie nie powiodły się) lub 64 (część się powiodła, a część nie).

+ Wersje starsze niż v2.36 nie mają udokumentowanego kodu zakończenia, natomiast 0 oznacza sukces we wszystkich wersjach.

ŚRODOWISKO

LIBMOUNT_DEBUG=all
    włącza wyjście debugowania libmount.

LIBBLKID_DEBUG=all
    włącza wyjście debugowania libblkid.

PLIKI

/dev/sd??
    standardowe urządzenia stronicowania

/etc/fstab
    tablica opisująca systemy plików w ascii

UWAGI

  Pliki z dziurami

Implementacja pliku wymiany w jądrze spodziewa się możliwości bezpośrednich zapisów do pliku, to jest bez pośrednictwa systemu plików. Stanowi to problem na plikach z dziurami oraz na systemach plików copy-on-write (kopiuj przy zapisie), takich jak Btrfs.

Polecenia takie jak cp(1) lub truncate(1) tworzą pliki z dziurami. Zostaną one odrzucone przez swapon.

Prealokowane pliki tworzone przez fallocate(1) mogą być również interpretowane jako pliki z dziurami, w zależności od systemu plików. Prealokowane pliki wymiany są obsługiwane w systemie plików XFS od jądra Linux w wersji 4.18.

Najbardziej przenośnym rozwiązaniem jest tworzenie plików wymiany za pomocą dd(1) i /dev/zero.

  Btrfs

Pliki wymiany w systemie plików Btrfs są obsługiwane od jądra Linux w wersji 5.0 (pliki z atrybutem nocow). Strona podręcznika systemowego btrfs(5) zawiera więcej informacji na ten temat.

  NFS

Swap poprzez NFS może nie działać.

  Stan wstrzymania

Polecenie swapon automatycznie wykrywa i nadpisuje podpis przestrzeni wymiany ze starymi danymi wstrzymania (np. S1SUSPEND, S2SUSPEND, ...). Jest to konieczne, gdyż w przeciwnym wypadku nastąpiłoby uszkodzenie danych przy kolejnej próbie wybudzenia.

HISTORIA

Polecenie swapon pojawiło się w 4.0BSD.

ZOBACZ TAKŻE

swapoff(2), swapon(2), fstab(5), init(8), fallocate(1), mkswap(8), mount(8), rc(8)

ZGŁASZANIE BŁĘDÓW

Raporty o błędach proszę zgłaszać pod adresem

DOSTĘPNOŚĆ

The swapon command is part of the util-linux package which can be downloaded from

T◈UMACZENIE
Autorami polskiego tłumaczenia niniejszej strony podręcznika są: Przemek Borys <pborys@dione.ids.pl>, Michał Kułach <michal.kulach@gmail.com> i Robert Luberda <robert@debian.org>

Niniejsze tłumaczenie jest wolną dokumentacją. Bliższe informacje o warunkach licencji można uzyskać zapoznając się z GNU General Public License w wersji 3 (https://www.gnu.org/licenses/gpl-3.0.html) lub nowszej. Nie przyjmuje się ŻADNEJ ODPOWIEDZIALNOŚCI.

Błędy w tłumaczeniu strony podręcznika prosimy zgłaszać na adres listy dyskusyjnej manpages-pl-list@lists.sourceforge.net.